var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { convertJsonKeys } from '@mj-studio/js-util';
import { constructUriWithQueryParams } from './constructUriWithQueryParams';
var initialSettings = {
    headers: {
        'Content-Type': 'application/json',
        Accept: 'application/json',
    },
    baseUrl: '',
    errorInterceptor: function (_a) {
        var error = _a.error;
        return error;
    },
    requestInterceptor: function (request) { return Promise.resolve(request); },
    responseInterceptor: function (response) { return Promise.resolve(response); },
    responseCodeWhiteListRange: { minInclude: 200, maxExclude: 300 },
    responseCodeWhiteList: [],
    responseCodeBlackList: [],
    serializedNames: {},
};
var settings = initialSettings;
export function setApiDefaultSettings(options) {
    settings = __assign(__assign({}, initialSettings), options);
}
export function clearApiDefaultSettings() {
    settings = initialSettings;
}
export function getApiDefaultSettings() {
    return settings;
}
/**
 * The method for uploading files to api server.
 * This method won't be used from external modules
 *
 * Note: **the properties in body object will be casted to string**
 * because of Content-Type is fixed with multipart/form-data
 *
 * @see https://dev.to/getd/x-www-form-urlencoded-or-form-data-explained-in-2-mins-5hk6
 */
function upload(uri, requestInit, files, body) {
    if (files === void 0) { files = []; }
    if (body === void 0) { body = {}; }
    var formData = new FormData();
    Object.entries(body).forEach(function (_a) {
        var key = _a[0], value = _a[1];
        formData.append(key, JSON.stringify(value));
    });
    Object.entries(files).forEach(function (_a) {
        var key = _a[0], file = _a[1];
        formData.append(key, file);
    });
    requestInit.headers && (requestInit.headers['Content-Type'] = 'multipart/form-data');
    requestInit.body = formData;
    return fetch(uri, requestInit);
}
function requestFormUrlEncoded(uri, requestInit, body) {
    var encodedBody = new URLSearchParams();
    if (body instanceof URLSearchParams) {
        encodedBody = body;
    }
    else if (body) {
        Object.entries(body).forEach(function (_a) {
            var key = _a[0], value = _a[1];
            encodedBody.set(encodeURIComponent(key), encodeURIComponent(value));
        });
    }
    requestInit.headers && (requestInit.headers['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8');
    if (!/GET/i.test(requestInit.method)) {
        requestInit.body = encodedBody;
    }
    return fetch(uri, requestInit);
}
function requestJson(uri, requestInit, body) {
    requestInit.headers && (requestInit.headers['Content-Type'] = 'application/json');
    body && (requestInit.body = JSON.stringify(body));
    return fetch(uri, requestInit);
}
function request(method, url, options) {
    var _this = this;
    var _a;
    if (options === void 0) { options = { headers: settings.headers }; }
    options.headers = options.headers || settings.headers;
    options.credentials = (_a = options.credentials) !== null && _a !== void 0 ? _a : settings.credentials;
    var optionsPromiseThunk = function () {
        return settings.requestInterceptor(options, {
            baseUrl: settings.baseUrl,
            url: url,
            method: method,
        });
    };
    return optionsPromiseThunk().then(function (options) { return __awaiter(_this, void 0, void 0, function () {
        var queryParams, body, files, headers, interceptor, mock, enableMock, requestMeta, mockError, credentials, baseUrl, constructedUri, requestInitWithoutBody, responsePromise, response, statusCode, _a, min, max, whiteList, blackList, responseData, contentType, _b, e_1, e_2, mergedSerializedNames, e_3, e_4, error, body, queryParams, url_1, statusCode;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _c.trys.push([0, 15, , 16]);
                    queryParams = options.queryParams, body = options.body, files = options.files, headers = options.headers, interceptor = options.interceptor, mock = options.mock, enableMock = options.enableMock, requestMeta = options.meta, mockError = options.mockError, credentials = options.credentials;
                    // Mocking for testing
                    if (enableMock) {
                        if (mockError) {
                            throw {
                                error: mockError,
                                body: body,
                                queryParams: queryParams,
                                url: url,
                                statusCode: 400,
                            };
                        }
                        return [2 /*return*/, mock];
                    }
                    baseUrl = typeof options.baseUrl === 'string'
                        ? options.baseUrl
                        : typeof settings.baseUrl === 'string'
                            ? settings.baseUrl
                            : undefined;
                    constructedUri = options.useRawUrl ? url : constructUriWithQueryParams(url, queryParams, baseUrl);
                    requestInitWithoutBody = {
                        headers: headers,
                        method: method,
                        credentials: credentials,
                    };
                    responsePromise = void 0;
                    if ((headers === null || headers === void 0 ? void 0 : headers['Content-Type']) === 'multipart/form-data' || (method === 'POST' && files)) {
                        responsePromise = upload(constructedUri, requestInitWithoutBody, files, body);
                    }
                    else if ((headers === null || headers === void 0 ? void 0 : headers['Content-Type']) === 'application/x-www-form-urlencoded;charset=UTF-8' ||
                        body instanceof URLSearchParams) {
                        responsePromise = requestFormUrlEncoded(constructedUri, requestInitWithoutBody, body);
                    }
                    else {
                        responsePromise = requestJson(constructedUri, requestInitWithoutBody, body);
                    }
                    return [4 /*yield*/, responsePromise];
                case 1:
                    response = _c.sent();
                    statusCode = response.status;
                    _a = settings.responseCodeWhiteListRange, min = _a.minInclude, max = _a.maxExclude;
                    whiteList = settings.responseCodeWhiteList;
                    blackList = settings.responseCodeBlackList;
                    if (((statusCode < min || statusCode >= max) && !whiteList.includes(statusCode)) ||
                        blackList.includes(statusCode)) {
                        throw {
                            error: new Error("Network Code Denied"),
                            body: body,
                            queryParams: queryParams,
                            url: url,
                            statusCode: statusCode,
                        };
                    }
                    responseData = void 0;
                    _c.label = 2;
                case 2:
                    _c.trys.push([2, 9, , 10]);
                    contentType = response.headers.get('Content-Type') || '';
                    _b = contentType.includes('text');
                    if (!_b) return [3 /*break*/, 4];
                    return [4 /*yield*/, response.text()];
                case 3:
                    _b = (_c.sent()).length;
                    _c.label = 4;
                case 4:
                    if (_b) {
                        throw new Error("response content-type is not application/json, value: " + contentType);
                    }
                    if (!contentType.includes('application/json')) return [3 /*break*/, 8];
                    _c.label = 5;
                case 5:
                    _c.trys.push([5, 7, , 8]);
                    return [4 /*yield*/, response.json()];
                case 6:
                    responseData = _c.sent();
                    return [3 /*break*/, 8];
                case 7:
                    e_1 = _c.sent();
                    responseData = undefined;
                    return [3 /*break*/, 8];
                case 8: return [3 /*break*/, 10];
                case 9:
                    e_2 = _c.sent();
                    throw {
                        error: e_2,
                        body: body,
                        queryParams: queryParams,
                        url: url,
                        statusCode: statusCode,
                    };
                case 10:
                    mergedSerializedNames = settings.serializedNames;
                    if (Object.keys(mergedSerializedNames).length) {
                        responseData = convertJsonKeys(responseData, mergedSerializedNames);
                    }
                    _c.label = 11;
                case 11:
                    _c.trys.push([11, 13, , 14]);
                    return [4 /*yield*/, settings.responseInterceptor(responseData, statusCode, url, method, requestMeta)];
                case 12:
                    responseData = _c.sent();
                    return [3 /*break*/, 14];
                case 13:
                    e_3 = _c.sent();
                    throw {
                        error: e_3,
                        body: body,
                        queryParams: queryParams,
                        url: url,
                        statusCode: statusCode,
                    };
                case 14:
                    if (interceptor) {
                        responseData = interceptor(responseData);
                    }
                    return [2 /*return*/, responseData];
                case 15:
                    e_4 = _c.sent();
                    if (typeof e_4.url === 'string') {
                        error = e_4.error, body = e_4.body, queryParams = e_4.queryParams, url_1 = e_4.url, statusCode = e_4.statusCode;
                        throw settings.errorInterceptor({
                            error: error,
                            body: body,
                            queryParams: queryParams,
                            url: url_1,
                            statusCode: statusCode,
                        });
                    }
                    else {
                        throw settings.errorInterceptor({ error: e_4, url: url, body: options.body, queryParams: options.queryParams });
                    }
                    return [3 /*break*/, 16];
                case 16: return [2 /*return*/];
            }
        });
    }); });
}
export default request;
//# sourceMappingURL=ApiClient.js.map