export function constructUriWithQueryParams(uri, queryParams, baseUrl) {
    if (baseUrl === void 0) { baseUrl = ''; }
    var parameters = new Map();
    try {
        var url = encodeURI(baseUrl + uri);
        var questionMarkIndex = url.indexOf('?');
        if (questionMarkIndex !== -1) {
            url
                .slice(questionMarkIndex + 1)
                .split('&')
                .forEach(function (raw) {
                var _a = raw.split('='), key = _a[0], value = _a[1];
                parameters.set(key, value);
            });
        }
        queryParams &&
            Object.entries(queryParams).forEach(function (_a) {
                var key = _a[0], value = _a[1];
                if (value !== undefined) {
                    parameters.set(key, value);
                }
            });
        var urlWithoutQueryParams = void 0;
        if (questionMarkIndex !== -1) {
            urlWithoutQueryParams = url.slice(0, questionMarkIndex);
        }
        else {
            urlWithoutQueryParams = url;
        }
        if (parameters.size === 0) {
            return urlWithoutQueryParams;
        }
        else {
            var queryParamsString_1 = '';
            parameters.forEach(function (value, key) {
                queryParamsString_1 += encodeURIComponent(key) + "=" + encodeURIComponent(value) + "&";
            });
            return urlWithoutQueryParams + '?' + queryParamsString_1.slice(0, -1);
        }
    }
    catch (e) {
        return uri;
    }
}
//# sourceMappingURL=constructUriWithQueryParams.js.map